<script lang="typescript">
  import { getNotifyAPI } from "src/apis/get-notify";

  import { getProductsAPI } from "src/apis/get-products";

  import { searchProductKeywordAPI } from "src/apis/search-product-keyword";

  import { Page } from "src/page";
  import { pageSelectedStore, userProfileStore } from "src/store";
  import { onMount } from "svelte";
  import NotifyIcon from "../notify/NotifyIcon.svelte";
  import ProfileIcon from "../profile/ProfileIcon.svelte";
  import ShopingCartIcon from "../shopingCart/ShopingCartIcon.svelte";

  let keyword: string = "";
  let timeoutClear: any;


  async function onSearchProductKeyword() {
    clearTimeout(timeoutClear);
    timeoutClear = setTimeout(async () => {
      if (keyword) {
        await searchProductKeywordAPI(keyword);
      } else {
        await getProductsAPI();
      }
    }, 1000);
  }
</script>

<header class="w-full shadow-lg bg-green-700 items-center h-16 z-40">
  <div
    class="relative z-20 flex flex-col justify-center h-full px-3 mx-auto flex-center"
  >
    <div
      class="relative items-center pl-1 flex w-full lg:max-w-68 sm:pr-2 sm:ml-0 justify-between"
    >
      <div
        on:click={() => ($pageSelectedStore = Page.PRODUCTS_LIST)}
        class="flex cursor-pointer"
      >
        <img class="w-20 h-20" alt="" src="./imgs/icon.png" />
      </div>
      <div class="relative left-0 z-50 flex w-3/4">
        <div class="relative flex items-center w-full lg:w-1/2 h-full group">
          <svg
            class="absolute left-0 z-20 hidden w-4 h-4 ml-4 text-gray-500 pointer-events-none fill-current group-hover:text-gray-400 sm:block"
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 20 20"
          >
            <path
              d="M12.9 14.32a8 8 0 1 1 1.41-1.41l5.35 5.33-1.42 1.42-5.33-5.34zM8 14A6 6 0 1 0 8 2a6 6 0 0 0 0 12z"
            />
          </svg>
          <input
            on:keyup={onSearchProductKeyword}
            bind:value={keyword}
            type="text"
            class="block w-full py-1.5 pl-10 pr-4 leading-normal rounded-2xl focus:border-transparent focus:outline-none focus:ring-2 focus:ring-blue-500 ring-opacity-90 bg-gray-100 dark:bg-gray-900 text-gray-900 aa-input"
            placeholder="ค้นหาสินค้า"
          />
        </div>
      </div>

      {#if ($userProfileStore || {}).image}
        <ProfileIcon />
        <NotifyIcon />
        <ShopingCartIcon />
      {:else}
        <div class="flex text-white items-center">
          <p
            on:click={() => ($pageSelectedStore = Page.LOGIN)}
            class="px-2 cursor-pointer hover:text-gray-900"
          >
            เข้าสู่ระบบ
          </p>
          <p
            on:click={() => ($pageSelectedStore = Page.REGISTER)}
            class="px-2 cursor-pointer hover:text-gray-900"
          >
            สมัครใหม่
          </p>
        </div>
      {/if}
    </div>
  </div>
</header>
